
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ExpensesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const expenses = await db.expenses.create(
            {
                id: data.id || undefined,
        
        expense_number: data.expense_number
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        expense_date: data.expense_date
        ||
        null
            ,
            
        amount: data.amount
        ||
        null
            ,
            
        payee: data.payee
        ||
        null
            ,
            
        payment_method: data.payment_method
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await expenses.setBranch( data.branch || null, {
            transaction,
        });
        
        await expenses.setExpense_account( data.expense_account || null, {
            transaction,
        });
        
        await expenses.setSubmitted_by( data.submitted_by || null, {
            transaction,
        });
        
        await expenses.setApproved_by( data.approved_by || null, {
            transaction,
        });
        
        await expenses.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.expenses.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: expenses.id,
            },
            data.attachments,
            options,
        );
        

        return expenses;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const expensesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                expense_number: item.expense_number
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                expense_date: item.expense_date
            ||
            null
            ,
            
                amount: item.amount
            ||
            null
            ,
            
                payee: item.payee
            ||
            null
            ,
            
                payment_method: item.payment_method
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const expenses = await db.expenses.bulkCreate(expensesData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < expenses.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.expenses.getTableName(),
                    belongsToColumn: 'attachments',
                    belongsToId: expenses[i].id,
                },
                data[i].attachments,
                options,
            );
        }
        

        return expenses;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const expenses = await db.expenses.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.expense_number !== undefined) updatePayload.expense_number = data.expense_number;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.expense_date !== undefined) updatePayload.expense_date = data.expense_date;
        
        
        if (data.amount !== undefined) updatePayload.amount = data.amount;
        
        
        if (data.payee !== undefined) updatePayload.payee = data.payee;
        
        
        if (data.payment_method !== undefined) updatePayload.payment_method = data.payment_method;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        updatePayload.updatedById = currentUser.id;

        await expenses.update(updatePayload, {transaction});

        
        
        if (data.branch !== undefined) {
            await expenses.setBranch(
              
              data.branch,
              
              { transaction }
            );
        }
        
        if (data.expense_account !== undefined) {
            await expenses.setExpense_account(
              
              data.expense_account,
              
              { transaction }
            );
        }
        
        if (data.submitted_by !== undefined) {
            await expenses.setSubmitted_by(
              
              data.submitted_by,
              
              { transaction }
            );
        }
        
        if (data.approved_by !== undefined) {
            await expenses.setApproved_by(
              
              data.approved_by,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await expenses.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.expenses.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: expenses.id,
            },
            data.attachments,
            options,
        );
        

        return expenses;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const expenses = await db.expenses.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of expenses) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of expenses) {
                await record.destroy({transaction});
            }
        });


        return expenses;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const expenses = await db.expenses.findByPk(id, options);

        await expenses.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await expenses.destroy({
            transaction
        });

        return expenses;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const expenses = await db.expenses.findOne(
            { where },
            { transaction },
        );

        if (!expenses) {
            return expenses;
        }

        const output = expenses.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.branch = await expenses.getBranch({
            transaction
        });
        
        
        output.expense_account = await expenses.getExpense_account({
            transaction
        });
        
        
        output.attachments = await expenses.getAttachments({
            transaction
        });
        
        
        output.submitted_by = await expenses.getSubmitted_by({
            transaction
        });
        
        
        output.approved_by = await expenses.getApproved_by({
            transaction
        });
        
        
        output.organizations = await expenses.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.branches,
        as: 'branch',
        
        where: filter.branch ? {
          [Op.or]: [
            { id: { [Op.in]: filter.branch.split('|').map(term => Utils.uuid(term)) } },
            {
              branch_name: {
                [Op.or]: filter.branch.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.chart_accounts,
        as: 'expense_account',
        
        where: filter.expense_account ? {
          [Op.or]: [
            { id: { [Op.in]: filter.expense_account.split('|').map(term => Utils.uuid(term)) } },
            {
              account_name: {
                [Op.or]: filter.expense_account.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'submitted_by',
        
        where: filter.submitted_by ? {
          [Op.or]: [
            { id: { [Op.in]: filter.submitted_by.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.submitted_by.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'approved_by',
        
        where: filter.approved_by ? {
          [Op.or]: [
            { id: { [Op.in]: filter.approved_by.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.approved_by.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



      {
        model: db.file,
        as: 'attachments',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.expense_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'expenses',
                        'expense_number',
                        filter.expense_number,
                    ),
                };
            }
            
            if (filter.payee) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'expenses',
                        'payee',
                        filter.payee,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'expenses',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            
            if (filter.expense_dateRange) {
                const [start, end] = filter.expense_dateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    expense_date: {
                    ...where.expense_date,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    expense_date: {
                    ...where.expense_date,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.amountRange) {
                const [start, end] = filter.amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    amount: {
                    ...where.amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    amount: {
                    ...where.amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            
            if (filter.payment_method) {
                where = {
                    ...where,
                payment_method: filter.payment_method,
            };
            }
            


      

      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.expenses.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'expenses',
                        'expense_number',
                        query,
                    ),
                ],
            };
        }

        const records = await db.expenses.findAll({
            attributes: [ 'id', 'expense_number' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['expense_number', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.expense_number,
        }));
    }

    
};

